ghc-7.0.3: The GHC API

X86.Regs

Synopsis

- virtualRegSqueeze :: RegClass -> VirtualReg -> FastInt
- realRegSqueeze :: RegClass -> RealReg -> FastInt
- data Imm
  - = ImmInt Int
  - | ImmInteger Integer
  - | ImmCLbl CLabel
  - | ImmLit Doc
  - | ImmIndex CLabel Int
  - | ImmFloat Rational
  - | ImmDouble Rational
  - | ImmConstantSum Imm Imm
  - | ImmConstantDiff Imm Imm
- strImmLit :: String -> Imm
- litToImm :: CmmLit -> Imm
- data AddrMode
  - = AddrBaseIndex EABase EAIndex Displacement
  - | ImmAddr Imm Int
- addrOffset :: AddrMode -> Int -> Maybe AddrMode
- spRel :: Int -> AddrMode
- argRegs :: RegNo -> [Reg]
- allArgRegs :: [Reg]
- callClobberedRegs :: [Reg]
- allMachRegNos :: [RegNo]
- classOfRealReg :: RealReg -> RegClass
- showReg :: RegNo -> String
- data EABase
  - = EABaseNone
  - | EABaseReg Reg
  - | EABaseRip
- data EAIndex
  - = EAIndexNone
  - | EAIndex Reg Int
- addrModeRegs :: AddrMode -> [Reg]
- eax :: Reg
- ebx :: Reg
- ecx :: Reg
- edx :: Reg
- esi :: Reg
- edi :: Reg
- ebp :: Reg
- esp :: Reg
- fake0 :: Reg
- fake1 :: Reg
- fake2 :: Reg
- fake3 :: Reg
- fake4 :: Reg
- fake5 :: Reg
- firstfake :: RegNo
- rax :: Reg
- rbx :: Reg
- rcx :: Reg
- rdx :: Reg
- rsi :: Reg
- rdi :: Reg
- rbp :: Reg
- rsp :: Reg
- r8 :: Reg
- r9 :: Reg
- r10 :: Reg
- r11 :: Reg
- r12 :: Reg
- r13 :: Reg
- r14 :: Reg
- r15 :: Reg
- xmm0 :: Reg
- xmm1 :: Reg
- xmm2 :: Reg
- xmm3 :: Reg
- xmm4 :: Reg
- xmm5 :: Reg
- xmm6 :: Reg
- xmm7 :: Reg
- xmm8 :: Reg
- xmm9 :: Reg
- xmm10 :: Reg
- xmm11 :: Reg
- xmm12 :: Reg
- xmm13 :: Reg
- xmm14 :: Reg
- xmm15 :: Reg
- xmm :: RegNo -> Reg
- ripRel :: Displacement -> AddrMode
- allFPArgRegs :: [Reg]
- freeReg :: RegNo -> FastBool
- globalRegMaybe :: GlobalReg -> Maybe RealReg
- allocatableRegs :: [RealReg]

# Documentation

virtualRegSqueeze :: RegClass -> VirtualReg -> FastInt Source

regSqueeze_class reg Calculuate the maximum number of register colors that could be denied to a node of this class due to having this reg as a neighbour.

realRegSqueeze :: RegClass -> RealReg -> FastInt Source

data Imm Source

Constructors

ImmInt Int |
ImmInteger Integer |
ImmCLbl CLabel |
ImmLit Doc |
ImmIndex CLabel Int |
ImmFloat Rational |
ImmDouble Rational |
ImmConstantSum Imm Imm |
ImmConstantDiff Imm Imm |

strImmLit :: String -> Imm Source

litToImm :: CmmLit -> Imm Source

data AddrMode Source

Constructors

AddrBaseIndex EABase EAIndex Displacement |
ImmAddr Imm Int |

addrOffset :: AddrMode -> Int -> Maybe AddrMode Source

spRelSource

Arguments

:: Int | desired stack offset in words, positive or negative
-> AddrMode |

argRegs :: RegNo -> [Reg]Source

allArgRegs :: [Reg]Source

callClobberedRegs :: [Reg]Source

allMachRegNos :: [RegNo]Source

The complete set of machine registers.

classOfRealReg :: RealReg -> RegClass Source

Take the class of a register.

showReg :: RegNo -> String Source

Get the name of the register with this number.

data EABase Source

Constructors

EABaseNone |
EABaseReg Reg |
EABaseRip |

data EAIndex Source

Constructors

EAIndexNone |
EAIndex Reg Int |

addrModeRegs :: AddrMode -> [Reg]Source

eax :: Reg Source

ebx :: Reg Source

ecx :: Reg Source

edx :: Reg Source

esi :: Reg Source

edi :: Reg Source

ebp :: Reg Source

esp :: Reg Source

fake0 :: Reg Source

fake1 :: Reg Source

fake2 :: Reg Source

fake3 :: Reg Source

fake4 :: Reg Source

fake5 :: Reg Source

firstfake :: RegNo Source

rax :: Reg Source

rbx :: Reg Source

rcx :: Reg Source

rdx :: Reg Source

rsi :: Reg Source

rdi :: Reg Source

rbp :: Reg Source

rsp :: Reg Source

r8 :: Reg Source

r9 :: Reg Source

r10 :: Reg Source

r11 :: Reg Source

r12 :: Reg Source

r13 :: Reg Source

r14 :: Reg Source

r15 :: Reg Source

xmm0 :: Reg Source

xmm1 :: Reg Source

xmm2 :: Reg Source

xmm3 :: Reg Source

xmm4 :: Reg Source

xmm5 :: Reg Source

xmm6 :: Reg Source

xmm7 :: Reg Source

xmm8 :: Reg Source

xmm9 :: Reg Source

xmm10 :: Reg Source

xmm11 :: Reg Source

xmm12 :: Reg Source

xmm13 :: Reg Source

xmm14 :: Reg Source

xmm15 :: Reg Source

xmm :: RegNo -> Reg Source

ripRel :: Displacement -> AddrMode Source

allFPArgRegs :: [Reg]Source

freeReg :: RegNo -> FastBool Source

globalRegMaybe :: GlobalReg -> Maybe RealReg Source

allocatableRegs :: [RealReg]Source

these are the regs which we cannot assume stay alive over a C call.